﻿@page "/vacation"
@using VacationSchedule.Core.Models.DB
@using VacationSchedule.Core.Models.DTO
@inject HttpClient Http

<PageTitle>Vacation</PageTitle>

<h1>Периоды отдыха</h1>

@if (vacations == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>С</th>
                <th>По</th>
                <th>Вид отдыха</th>
                <th>Примечание</th>
                <th>Утвержден</th>
                <th>Действия</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var vacation in vacations)
            {
                <tr>
                    <td>@vacation.VacationStartDate.ToString("dd.MM.yyyy")</td>
                    <td>@vacation.VacationEndDate.ToString("dd.MM.yyyy")</td>
                    <td>@vacation.VacationType.Name</td>
                    <td><input type="text" class="form-control" disabled="@vacation.IsAccepted || @vacation.VacationTypeId != 1" @bind="@vacation.Comment" /></td>
                    <td align="center"><input type="checkbox" checked="@(vacation.IsAccepted)" disabled="true" style="width:20px; height:20px;" /></td>
                    <td><button disabled="@vacation.IsAccepted" class="btn btn-primary" @onclick="@(e => DelVac(vacation.Id))">Delete</button></td>
                </tr>
            }
            <tr>
                <td>
                    <input type="date" class="form-control" placeholder="Дата начала" @bind="newVacation.VacationStartDate" />
                </td>
                <td>
                    <input type="date" class="form-control" placeholder="Дата окончания" @bind="newVacation.VacationEndDate" />
                </td>
                <td>
                    <select class="form-control selectpicker" @bind=@getType(newVacation).Id>
                        <option value="-1">--select--</option>
                        @foreach (var item in vacationTypes)
                        {
                            <option value="@item.Id">@item.Name </option>
                        }
                    </select>
                </td>
                <td><input type="text" class="form-control" @bind="@newVacation.Comment" /></td>
                <td></td>
                <td>
                    <button class="btn btn-primary" @onclick="@(e => AddVac(newVacation))">Add</button>
                </td>
            </tr>
        </tbody>
    </table>

    @if (ShowDialog)
    {
         <div class="modal fade show d-block" id="cityModal" tabindex="-1" role="dialog">  
            <div class="modal-dialog">  
                <div class="modal-content">  
                    <div class="modal-header">  
                        <h5 class="modal-title" id="lbl">Ошибка</h5>
                    </div>  
                    <div class="modal-body">
                        <h5 class="modal-title" id="lbl">@message</h5>
                    </div>  
                     <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" @onclick="hideDialog" data-dismiss="modal">Close</button>
                    </div>
                </div>  
            </div>  
        </div>  
    }
}

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private VacationType[] vacationTypes;
    private Vacation[] vacations;
    private Vacation newVacation;
    private User user;
    AuthenticationState state;

    private bool ShowDialog = false;
    private string message= "";


    protected override async Task OnInitializedAsync()
    {
        state = await authenticationStateTask;
        user = await Http.GetFromJsonAsync<User>($"api/User/GetByUserName?userName={state.User.Identity.Name}");
        vacationTypes = await Http.GetFromJsonAsync<VacationType[]>("api/VacationType");
        await RefreshData();
    }

    private async Task RefreshData()
    {
        vacations = await Http.GetFromJsonAsync<Vacation[]>($"api/Vacation/GetByUserId?id={user.Id}");
        newVacation = NewContact();
    }

    private async Task AddVac(Vacation vacation)
    {
        var res = await Http.PostAsJsonAsync<Vacation>($"api/Vacation", vacation);
        if (res.StatusCode != System.Net.HttpStatusCode.OK)
        {
            message = await res.Content.ReadAsStringAsync();
            ShowDialog = true;
        }
        await RefreshData();
    }

    private async Task DelVac(int vacationId)
    {
        var res = await Http.DeleteAsync($"api/Vacation/"+ vacationId);
        if(res.StatusCode != System.Net.HttpStatusCode.OK)
        {
            message = await res.Content.ReadAsStringAsync();
            ShowDialog = true;
        }
        await RefreshData();
    }

    void hideDialog()
    {
        ShowDialog = false;
    }

    private VacationType getType(Vacation vacation)
    {
        if (vacation.VacationType is not null)
        {
            return vacation.VacationType;
        }
        return new VacationType { Id = -1 };
    }

    private Vacation NewContact() => new()
        {
            UserId = user.Id,
            VacationStartDate = DateTime.Now.Date,
            VacationEndDate = DateTime.Now.Date,
            VacationType = new VacationType { Id = -1 }
        };
}
